@make(ais)
@aiInfo(topic=<Lexical elements not changed by allowable character replacements>,
number=[AI-00350/04],
classcode=[ra],
statuscode=[WJ],
mainref=[06.03.01@\(05)],
date=[86-12-04])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
@standard[02.10@\(05)]
!class ramification 86-04-14
!status approved by WG9/AJPO 86-11-26
@end(toplines)
!status approved by Director, AJPO 86-11-26
!status approved by WG9/Ada Board 86-11-18
!status panel/committee-approved 86-08-07 (reviewed)
!status committee-approved (8-1-0) 86-05-12 (pending editorial review)
!status work-item 86-04-10
!status received 85-06-18
@references[!references @CommentNum[83-00554]83-00554]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 86-04-14]

Lexical elements differing only in their use of allowable replacements of
characters (as defined in 2.10) are considered as the same.  In particular,
use of the allowable replacements does not affect the conformance of formal
parts, discriminant parts, or actual parameters.

@subheading[!question 86-06-26]

Is a replacement allowed by 2.10 a sufficient change to form a different
lexical element?  For example:
@begin(example)
@key[procedure] P(S : String := (1 | 2 | 3 => 'x')); -- P1
-- Vertical bars in aggregate
@hinge()

@key[procedure] P(S : String := (1 | 2 ! 3 => 'x'))  -- P2
-- Exclamation mark in aggregate
@key[is] ... @key[end] P;
@hinge()

@key[procedure] Q(S : String := "Foo%bar");          -- Q1
-- Double quotes in string
@hinge()

@key[procedure] Q(S : String := %Foo%%bar%)          -- Q2
-- Percent signs in string
@key[is] ... @key[end] Q
@end(example)
Although the inconsistent usage of replacement of characters is not
good programming practice, do P2 and Q2 conform to P1 and Q1,
respectively?

@subheading[!response 86-12-04]

6.3.1(5) states:
@begin(quotation)
Two subprogram  specifications are  said to  conform if,  apart
from  [certain   variations   allowed  by   6.3.1(2-4)],   both
specifications are  formed  by  the same  sequence  of  lexical
elements, and corresponding lexical elements are given the same
meaning by the visibility and overloading rules.
@end(quotation)
2.10(1-4) defines allowable replacements for the vertical bar, sharp, and
quotation characters in programs.  2.10(5) then says:
@begin(quotation)
These replacements do not change the meaning of the program.
@end(quotation)
In particular, use of the allowed replacements does not change the meaning of
a program with respect to the conformance rules, i.e., a legal program cannot
become illegal just because a lexical element has been changed by use of an
allowed character replacement.  Hence, P2 and Q2 conform to P1 and Q1,
respectively.

